      program unformat
c Este programa que transforma em binario a lista de estacoes meteorologicas da WMO
c gera o arquivo station_list.dat que e' lido pelos programas mdb do preprocessamento de dados
c que necessitam informacoes das estacoes meteorologicas como lat/lon/alt...
c
c  ultima alteracao - R.Cintra - 01.10.1999
c
      dimension iparams(33000),ipoints(128),ipoint1(128)
      integer   nwpt,nbpt
      integer   ISTNO,IPCODE,KNMS,ID,ILON,ILAT,ISGLAT
      integer   IRN,ICOUN,ISTIND,ITYPE1,ITYPE2,ITYPE3
      
      data ipoints/128*0/,ipoint1/128*0/,iparams/33000*0/
c
       open(unit=22,file='station_list.dat',iostat=ios,err=300,
     1             form='unformatted',
     2             status='new')
     
       open(unit=21,file='formatted_station.dat',iostat=ios,err=301,
     1             form='formatted',
     2             recl=80,
     2             status='old')
c
      nwpt=1
      nbpt=0
      
      do 100 i=1,11000      
      read(21,'(2I3,i1,I5,2i7,2i1,i5,4i1)',iostat=ios,err=120) 
     1      ISTNO,IPCODE,KNMS,ID,ILON,ILAT,ISGLAT,
     1      IRN,ICOUN,ISTIND,ITYPE1,ITYPE2,ITYPE3

      CALL PACK(32,IPARAMS(NWPT),ISTno   ,NWPT,NBPT,10)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,06)
      CALL PACK(32,IPARAMS(NWPT),IPCODE,NWPT,NBPT,04)
      CALL PACK(32,IPARAMS(NWPT),KNMS  ,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,03)
      CALL PACK(32,IPARAMS(NWPT),ID    ,NWPT,NBPT,14)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,02)
      CALL PACK(32,IPARAMS(NWPT),ILON  ,NWPT,NBPT,16)
      CALL PACK(32,IPARAMS(NWPT),ILAT  ,NWPT,NBPT,14)
      CALL PACK(32,IPARAMS(NWPT),ISGLAT,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),IRN   ,NWPT,NBPT,03)
      CALL PACK(32,IPARAMS(NWPT),ICOUN ,NWPT,NBPT,10)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,03)
      CALL PACK(32,IPARAMS(NWPT),1     ,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),ISTIND,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),ITYPE1,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),ITYPE2,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),ITYPE3,NWPT,NBPT,01)
      CALL PACK(32,IPARAMS(NWPT),0     ,NWPT,NBPT,03)
          
c      if ((nwpt-3) .ge. 586  .and. (nwpt-3) .le. 1053) then 
c         print*,'istno = ',istno
c         CALL GBYTE(IPARAMS(nwpt-3),ISTN,0,10)
c         print*,'nwp/estacao = ',(nwpt-3),istn
c      endif
c
 100    continue
c               
      read(21,'(i12)') ipoint1
      
      j = 2
      if (ipoint1(1) .eq. 0) then
        print*,'ipoint1= ',ipoint1(1)
      
       do 200 i=1,127
       ipoints(i)=ipoint1(j)
       j = j + 1     
       print*,i,ipoints(i)
 200  continue
       ipoints(i)=0
       print*,i,ipoints(i) 
      else
       do 201 i=1,128
       ipoints(i)=ipoint1(i)   
       print*,i,ipoints(i)
 201  continue 
      endif
      
      write(22) iparams,ipoints     
      close(21)
      close(22)
      stop
c
 120  print*,' erro de leitura',ios
      stop
       
 300  continue
      print*,'Open error on station_list.dat'
      stop
      
 301  continue
      print*,'Open error on formatted_station.dat'
      stop 
      
      end
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     *METHOD.
C      -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
c
      SUBROUTINE INVBYTES(ILEN,YBUFF)

C
C**** *INVBYTES*
C     INVERTS BYTE ORDERING OF STRING YBUFF (EFOF)
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO MAKE AN INVERSION OF ALL
c     THE FOUR BITS OF A WORD.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INVBYTES(ILEN,YBUFF)*
C



      CHARACTER*163840 YBUFF

      CHARACTER*1 TEMP

      NWORDS=(ILEN-1)/4 +1
      DO 100 I=1,NWORDS
         IBYTE1=(I-1)*4 +1
         IBYTE2=IBYTE1+1
         IBYTE3=IBYTE1+2
         IBYTE4=IBYTE1+3
         TEMP=YBUFF(IBYTE1:IBYTE1)
         YBUFF(IBYTE1:IBYTE1)=YBUFF(IBYTE4:IBYTE4)
         YBUFF(IBYTE4:IBYTE4)=TEMP
         TEMP=YBUFF(IBYTE2:IBYTE2)
         YBUFF(IBYTE2:IBYTE2)=YBUFF(IBYTE3:IBYTE3)
         YBUFF(IBYTE3:IBYTE3)=TEMP
100   CONTINUE
      RETURN
      END
