#! /bin/csh 
#
#################################################################################									       
#                                 Shell Script
#
#          Usado para gerar a tabela binaria station_list, para ser utilizada 
#                     nos decodificadores do ECMWF/CPTEC  
#
################################################################################# 
#	     Pega dados do arquivo formatted_station.dat.amend
#                gerando o arquivo binario station_list.dat
#################################################################################
#                   Compila os Programas: station_formatted.f             
#            		                  station.unformat.f               
#	  Gera os executaveis station_formatted.exe e station.unformat.exe                  
#
#################################################################################

#                       Feito por: Ana Lucia - 22/03/2004  

#################################################################################

#             Verifica se o Shell Scrip foi rodado corretamente
clear

if ( $1 == 'tables' ) then

#################################################################################
#             Verifica se o arquivo formatted_station.dat.amend exite

echo " "
echo "1- Verificando arquivo formatted_station.dat.amend"

if (! -e formatted_station.dat.amend ) then
   echo "Arquivo: formatted_station.dat.amend nao encontrado" 
   echo " "
   exit
else
   echo "Arquivo Encontrado"
   echo " "
endif

#################################################################################
#                   Verifica se a biblioteca pbio.a exite

echo "2- Verificando biblioteca pbio.a " 
if (! -e pbio.a ) then
   echo "Biblioteca: pbio.a nao Encontrada"
   echo " "
   exit
else
   echo "Biblioteca Encontrada"
   echo " "
endif

#################################################################################            
#                       Apaga os arquivos caso exista


if( -e station_formatted.exe ) then
	rm -f station_formatted.exe
endif

                    
if( -e station.unformat.exe ) then
	rm -f station.unformat.exe
endif


if( -e station_list.dat ) then
	rm -f station_list.dat
endif

if( -e formatted_station.dat ) then
	rm -f formatted_station.dat

endif


################################################################################
#                        Compila os programas em F90

echo "3- Compilando o programa station_formatted.f  "

f90 station_formatted.f -o station_formatted.exe

if(! -e station_formatted.exe ) then
	echo "Nao foi possivel compilar station_formatted.f"
	exit
else
	echo "Compilacao OK" 
endif

echo " "
 
echo "4- Compilando o programa station_unformat.f "


f90 station_unformat.f pbio.a -o station.unformat.exe

if(! -e station.unformat.exe ) then
	echo "Nao foi possivel compilar station_unformat.f"
	exit
else
	echo "Compilacao OK" 
endif
echo " "

#################################################################################                
#      Executa os programas gerados pelo compilador e grava no tables.log

echo "5- Executando station_formatted.exe e gravando no arquivo tables.log" 
station_formatted.exe > tables.log 
if (! -e formatted_station.dat) then
	echo "Nao foi possivel executar o arquivo"
	exit
else
	echo "Execucao OK " 
	station.unformat.exe >> tables.log
	echo " "
	echo "6- Executando station.unformat.exe e gravando no arquivo tables.log" 
	if(! -e station_list.dat) then
		echo "Nao foi possivel executar o arquivo"
		exit
	else
		echo "Execucao OK "
	endif
	
endif
echo " " 
	

################################################################################
#                        Apaga os arquivos gerados
 
#rm -f station_formatted.exe
#rm -f station.unformat.exe
#rm -f formatted_station.dat

################################################################################              
#               Mostra como o Shell Script deve ser executado		 
else
	
	echo " "
	echo "Para rodar o Shell Script digite: tables.csh tables"
	echo "ou consulte o readme.txt" 
        echo " "
endif
################################################################################
